﻿Imports System.Data.OleDb
Imports System.IO

Public Class FTestDataGrid

    Dim DT As DataTable

    ' El separador DEBE SER la COMA ( ,   y no ; ). en otra manera, debemos escribir un fichero SYSTEM.INI y 
    ' lo poner en la mismas carpeta que el fichero CSV . este INI puede ser escrito por este programa, ante este procedimiento
    Dim CadenaDeConexion = "Provider=Microsoft.Ace.OLEDB.12.0;Data Source=" & CurDir() & "\;" & "Extended Properties=""text;HDR=Yes;FMT=Delimited()"""

    Dim FicheroCSV As StreamWriter

    Dim TablaPrueba(,) As String

    Private Sub ValoresIniciales()
        TablaPrueba =
{
{"00", "A", "1", "6"},
{"01", "B", "1", "5"},
{"02", "C", "1", "6"},
{"03", "A", "2", "6"},
{"04", "A", "3", "4"},
{"05", "B", "2", "5"},
{"06", "B", "3", "3"},
{"07", "C", "2", "5"},
{"08", "C", "3", "4"},
{"09", "A", "4", "4"},
{"10", "A", "5", "2"},
{"11", "A", "6", "2"},
{"12", "B", "4", "3"},
{"13", "B", "5", "1"},
{"14", "B", "6", "1"},
{"15", "C", "4", "3"},
{"16", "C", "5", "2"},
{"17", "C", "6", "1"}
}
    End Sub

    Private Sub FTestTriDGV_Load(sender As Object, e As EventArgs) Handles Me.Load

        BReiniciar_Click(Me, Nothing)

    End Sub

    Private Sub BReiniciar_Click(sender As Object, e As EventArgs) Handles BReiniciar.Click

        ValoresIniciales()

        ' Prepare el DataTable  : el DataTable permite de poner facilmente los Datos en el DGV

        If Not DT Is Nothing Then DT.Dispose()
        DT = New DataTable
        DT.Columns.Add("Inicial")
        DT.Columns.Add("Letras")
        DT.Columns.Add("Num_1")
        DT.Columns.Add("Num_2")
        DT.TableName = "MisDatos"

        For Linea As Integer = 0 To 17
            DT.Rows.Add(TablaPrueba(Linea, 0), TablaPrueba(Linea, 1), TablaPrueba(Linea, 2), TablaPrueba(Linea, 3))
        Next

        TablaPruebaToCSV()   ' escribir los datos en un fichero CSV para ordenar mas tarde. este fichero puede ser leido como una DB, con una consulta SQL, con ORDER BY.

        DGV.DataSource = DT

        TBLlave1.Text = ""
        TBLlave2.Text = ""
        TBLlave3.Text = ""
        RbASC1.Checked = True
        RbASC2.Checked = True
        RbASC3.Checked = True


    End Sub

    Private Sub TablaPruebaToCSV()

        FicheroCSV = New StreamWriter("MisDatosTmp.CSV", False)
        Dim LineaAGrabar As String

        LineaAGrabar = ""
        For C As Integer = 0 To 3
            LineaAGrabar &= DT.Columns(C).ColumnName & ","
        Next
        FicheroCSV.WriteLine(LineaAGrabar)

        For Linea As Integer = 0 To 17
            LineaAGrabar = ""
            For C As Integer = 0 To 3
                LineaAGrabar &= DT.Rows(Linea).Item(C) & ","
            Next
            FicheroCSV.WriteLine(LineaAGrabar)
        Next

        FicheroCSV.Close()
    End Sub

    Private Sub BSort(sender As Object, e As EventArgs) Handles BSortDatos.Click
        Dim CadenaOrder As String = ""
        If Not TBLlave1.Text = String.Empty Then
            CadenaOrder = " ORDER BY " & TBLlave1.Text & " " & IIf(RbASC1.Checked, "ASC", "DESC")
            If Not TBLlave2.Text = String.Empty Then
                CadenaOrder &= ", " & TBLlave2.Text & " " & IIf(RbASC2.Checked, "ASC", "DESC")
                If Not TBLlave3.Text = String.Empty Then
                    CadenaOrder &= ", " & TBLlave3.Text & " " & IIf(RbASC3.Checked, "ASC", "DESC")
                    CargarDGVConDatosOrdenar(CadenaOrder) ' Si existen Lleva1, Lleva2 y Lleva3, trabajar con Llena1, Lleva2 y Lleva3
                Else
                    CargarDGVConDatosOrdenar(CadenaOrder) ' Si existen Lleva1 y Lleva2 sin Lleva3, trabajar con Llena1 y Lleva2
                    Exit Sub
                End If
            Else
                CargarDGVConDatosOrdenar(CadenaOrder) ' Si existe Lleva1 sin Lleva2, trabajar con Llena1 
                Exit Sub
            End If
        Else
            Exit Sub   ' Si no existe Lleva1, entonces nada hacer
        End If
    End Sub

    Private Sub CargarDGVConDatosOrdenar(CadenaOrder As String)

        If Not DT Is Nothing Then DT.Dispose()
        DT = New DataTable
        Dim MiConexion As New OleDbConnection
        Dim Consulta As String

        MiConexion.ConnectionString = CadenaDeConexion
        Consulta = "Select * FROM MisDatosTmp.csv " & CadenaOrder

        ' .... Con Adapter
        Dim MiAdapter As OleDbDataAdapter = New OleDbDataAdapter(Consulta, MiConexion)
        MiAdapter.Fill(DT)
        MiAdapter.Dispose()

        DGV.DataSource = Nothing
        DGV.Rows.Clear()
        DGV.DataSource = DT

    End Sub

End Class


